unit ListerForm;
(***********************************************************************
 *                                                                     *
 *  Copyright (C) 1997-19..                                            *
 *  Arbeitsgruppe KI-Labor Fachbereich Informatik Universitaet Bremen  *
 *                                                                     *
 *  Version     :       2.0                                            *
 *                                                                     *
 *  Beschreibung:                                                      *
 *                                                                     *
 *  Autor       :       Erol S. Uzuner                                 *
 *                                                                     *
 *  Datum       :       Dezember 1999                                  *
 *                                                                     *
 *                                                                     *
 *  Aenderungen :                                                      *
 *  Datum        Autor          Beschreibung                           *
 *                                                                     *
 ***********************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HeadList, Stres;

type
  TfrmLister = class(TForm)
  HeaderListbox1: THeaderListbox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure ToHtml(Strings : TStringList);
  end;

var
  frmLister: TfrmLister;

implementation

{$R *.DFM}

procedure TfrmLister.FormClose(Sender: TObject; var Action: TCloseAction);
begin Action := caFree;
end;

{Iterate trough all Entrys and write out as HTML code}

procedure TfrmLister.ToHtml(Strings : TStringList);
const TABLE_COMMENT = '<!-- Listing of table: ';
      PARAGRAPH_OPEN = '<p style="font-family:Verdana,sans-serif,Arial;">';
      PARAGRAPH_CLOSE = '</p>';
      TABLE_OPEN = '<table border="1" bgcolor="#ffffee">';
      TABLE_CLOSE = '</table>';
      ROW_OPEN  = '<tr>';
      ROW_CLOSE = '</tr>';
      COL_OPEN  = '<td>';
      COL_CLOSE = '</td>';
      NAME_COL_OPEN = '<td colspan="3" bgcolor="#00ccff">';
      TARGET_OPEN =  '<a name=';
      TARGET_CLOSE = '</a>';
      NAME_FONT_OPEN = '<font face="Arial" size="+1">';
      FONT_CLOSE = '</font>';
      HEADER_COL_OPEN = '<td bgcolor="#aaaaaa">';
      INDEX_COL_OPEN = '<td bgcolor="#ffffbb">';
      ITALIC_OPEN = '<i>';
      ITALIC_CLOSE = '</i>';
var i : Integer;
    st : TStrTokenizer;
    str, colstr : String;
begin
     strings.add('');
     strings.add(Format('%s %s -->', [TABLE_COMMENT, Caption]));
     strings.add(PARAGRAPH_OPEN);
     strings.add(TABLE_OPEN);

     // Name der Tabelle
     strings.add(ROW_OPEN);
     strings.add(Format( '%s %s"%s"> %s%s%s %s',
                         [NAME_COL_OPEN, TARGET_OPEN, Caption, NAME_FONT_OPEN,
                          Caption, FONT_CLOSE, TARGET_CLOSE, COL_CLOSE]));
     strings.add(ROW_CLOSE);

     // Spalten berschriften
     strings.add(ROW_OPEN);
     strings.add(Format( '%s %s%s%s %s',
                         [HEADER_COL_OPEN, ITALIC_OPEN,
                         HeaderListBox1.Sections[0].Text , ITALIC_CLOSE, COL_CLOSE]));
     strings.add(Format( '%s %s%s%s %s',
                         [HEADER_COL_OPEN, ITALIC_OPEN,
                         HeaderListBox1.Sections[1].Text , ITALIC_CLOSE, COL_CLOSE]));
     strings.add(Format( '%s %s%s%s %s',
                         [HEADER_COL_OPEN, ITALIC_OPEN,
                         HeaderListBox1.Sections[2].Text , ITALIC_CLOSE, COL_CLOSE]));
     strings.add(ROW_CLOSE);

     // Felder
     st := TStrTokenizer.Create('',HeaderListBox1.DelimChar, false);
     for i:= 0 to HeaderListBox1.items.count-1 do begin
        st.reset(HeaderListBox1.items[i], HeaderListBox1.DelimChar, false);
        strings.add(ROW_OPEN);
        str := st.NextToken;
        if Pos('*', str) > 0 then
             colstr := INDEX_COL_OPEN
        else colstr := COL_OPEN;
        strings.add(Format('%s %s %s', [colstr, str, COL_CLOSE]));
        strings.add(Format('%s %s %s', [colstr, st.NextToken , COL_CLOSE]));
        strings.add(Format('%s %s %s', [colstr, st.NextToken , COL_CLOSE]));
        strings.add(ROW_CLOSE);
     end;
     strings.add(ROW_CLOSE);
     st.Free;

     strings.add(TABLE_CLOSE);
     strings.add(PARAGRAPH_CLOSE);
end;

end.
